## metaeuk 6

=== src/version/CMakeLists.txt ===
add_library(version Version.cpp)

if (VERSION_OVERRIDE)
    target_compile_definitions(version PRIVATE -DGIT_SHA1=${VERSION_OVERRIDE})
else()
    include(GetGitRevisionDescription)
    get_git_head_revision(GIT_REFSPEC GIT_SHA1)
    target_compile_definitions(version PRIVATE -DGIT_SHA1=${GIT_SHA1})
endif()

if (${HAVE_MPI})
    target_compile_definitions(version PRIVATE -DHAVE_MPI=${HAVE_MPI})
endif()

=== lib/mmseqs/src/CMakeLists.txt ===
set(HAVE_MPI 0 CACHE BOOL "Have MPI")
set(HAVE_TESTS 0 CACHE BOOL "Have Tests")
set(HAVE_SHELLCHECK 1 CACHE BOOL "Have ShellCheck")
set(HAVE_GPROF 0 CACHE BOOL "Have GPROF Profiler")
set(ENABLE_WERROR 0 CACHE BOOL "Enable Warnings as Errors")
#set(DISABLE_LTO 0 CACHE BOOL "Disable link-time optimization in non-debug builds")
set(REQUIRE_OPENMP 1 CACHE BOOL "Require availability of OpenMP")

include(AppendTargetProperty)

add_subdirectory(alignment)
add_subdirectory(clustering)
add_subdirectory(commons)
add_subdirectory(linclust)
add_subdirectory(multihit)
add_subdirectory(prefiltering)
add_subdirectory(taxonomy)
add_subdirectory(util)
add_subdirectory(workflow)

add_library(mmseqs-framework
        $<TARGET_OBJECTS:alp>
        $<TARGET_OBJECTS:ksw2>
        $<TARGET_OBJECTS:cacode>
        ${alignment_header_files}
        ${alignment_source_files}
        ${clustering_header_files}
        ${clustering_source_files}
        ${commons_header_files}
        ${commons_source_files}
        ${prefiltering_header_files}
        ${prefiltering_source_files}
        ${multihit_header_files}
        ${multihit_source_files}
        ${taxonomy_header_files}
        ${taxonomy_source_files}
        ${linclust_source_files}
        ${util_header_files}
        ${util_source_files}
        ${workflow_source_files}
        CommandDeclarations.h
        MMseqsBase.cpp
        )

target_include_directories(mmseqs-framework PUBLIC ${CMAKE_BINARY_DIR}/generated)
target_include_directories(mmseqs-framework PUBLIC ${PROJECT_BINARY_DIR}/generated)
target_include_directories(mmseqs-framework PUBLIC alignment)
target_include_directories(mmseqs-framework PUBLIC clustering)
target_include_directories(mmseqs-framework PUBLIC commons)
target_include_directories(mmseqs-framework PUBLIC multihit)
target_include_directories(mmseqs-framework PUBLIC prefiltering)
target_include_directories(mmseqs-framework PUBLIC linclust)
target_include_directories(mmseqs-framework PUBLIC taxonomy)
target_include_directories(mmseqs-framework PUBLIC util)
target_include_directories(mmseqs-framework PUBLIC .)

add_dependencies(mmseqs-framework generated)

#if (NOT DISABLE_LTO)
#    string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)
#    if (uppercase_CMAKE_BUILD_TYPE MATCHES "^(RELEASE|RELWITHDEBINFO|MINSIZEREL)$")
#        cmake_policy(SET CMP0069 NEW)
#        include(CheckIPOSupported)
#        check_ipo_supported(RESULT IPO_SUPPORTED)
#        if (IPO_SUPPORTED)
#            set_property(TARGET mmseqs-framework PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
#        endif ()
#    endif ()
#endif ()

append_target_property(mmseqs-framework COMPILE_FLAGS ${MMSEQS_CXX_FLAGS} -pedantic -Wall -Wextra -Wdisabled-optimization)
append_target_property(mmseqs-framework LINK_FLAGS ${MMSEQS_CXX_FLAGS} -pedantic -Wall -Wextra -Wdisabled-optimization)
if (NOT EMSCRIPTEN)
    append_target_property(mmseqs-framework COMPILE_FLAGS -fno-exceptions)
    append_target_property(mmseqs-framework LINK_FLAGS -fno-exceptions)
endif()

if (ENABLE_WERROR)
    append_target_property(mmseqs-framework COMPILE_FLAGS -Werror)
    append_target_property(mmseqs-framework LINK_FLAGS -Werror)
endif()

# needed for concat.h
include(CheckCXXSourceCompiles)
check_cxx_source_compiles("
        #include <stdlib.h>
        #include <fcntl.h>
        #include <stdio.h>

        int main() {
          FILE* tmpf = tmpfile();
          int input_desc = fileno(tmpf);
          int test = posix_fadvise(input_desc, 0, 0, POSIX_FADV_SEQUENTIAL);
          fclose(tmpf);
          return 0;
        }"
        HAVE_POSIX_FADVISE)
if (HAVE_POSIX_FADVISE)
    target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_POSIX_FADVISE=1)
endif ()

check_cxx_source_compiles("
        #include <stdlib.h>
        #include <fcntl.h>
        #include <stdio.h>
        #include <sys/mman.h>

        int main() {
          FILE* tmpf = tmpfile();
          void *tmp = mmap(NULL, 32, PROT_READ, MAP_SHARED, fileno(tmpf), 0);
          int test = posix_madvise(tmp, 32, POSIX_MADV_SEQUENTIAL);
          fclose(tmpf);
          return 0;
        }"
        HAVE_POSIX_MADVISE)
if (HAVE_POSIX_MADVISE)
    target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_POSIX_MADVISE=1)
endif ()

if (NOT DISABLE_IPS4O)
    find_package(Atomic)
    if (ATOMIC_FOUND)
        target_link_libraries(mmseqs-framework ${ATOMIC_LIBRARIES})
        target_compile_definitions(mmseqs-framework PUBLIC -DENABLE_IPS4O=1)
        message("-- IPS4O sorting works")
    else ()
        message("-- OMPTL sorting fallback")
    endif ()
else ()
    message("-- OMPTL sorting fallback")
endif ()

target_link_libraries(mmseqs-framework tinyexpr ${ZSTD_LIBRARIES} microtar)
if (CYGWIN)
    target_link_libraries(mmseqs-framework nedmalloc)
endif ()

if (EMSCRIPTEN)
    target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_ZLIB=1 -DHAVE_BZLIB=1)
    append_target_property(mmseqs-framework COMPILE_FLAGS -s USE_ZLIB=1 -s USE_BZIP2=1)
    append_target_property(mmseqs-framework LINK_FLAGS -s USE_ZLIB=1 -s USE_BZIP2=1)
else ()
find_package(ZLIB QUIET)
if (ZLIB_FOUND)
    message("-- Found ZLIB")
    set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
    set(OLD_CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES})
    set(OLD_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
    set(CMAKE_REQUIRED_FLAGS -lz)
    set(CMAKE_REQUIRED_INCLUDES ${ZLIB_INCLUDE_DIRS})
    set(CMAKE_REQUIRED_LIBRARIES ${ZLIB_LIBRARIES})
    check_cxx_source_compiles("
        #include <zlib.h>
        int main() { gzFile file; return 0; }"
        HAVE_ZLIB_CHECK)
    set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQUIRED_FLAGS})
    set(CMAKE_REQUIRED_INCLUDES ${OLD_CMAKE_REQUIRED_INCLUDES})
    set(CMAKE_REQUIRED_LIBRARIES ${OLD_CMAKE_REQUIRED_LIBRARIES})
    if(HAVE_ZLIB_CHECK)
        message("-- ZLIB works")
        target_include_directories(mmseqs-framework PUBLIC ${ZLIB_INCLUDE_DIRS})
        target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_ZLIB=1)
        target_link_libraries(mmseqs-framework ${ZLIB_LIBRARIES})
    else ()
        message("-- ZLIB does not work")
    endif()
else ()
    message("-- Could not find ZLIB")
endif ()

find_package(BZip2 QUIET)
if (BZIP2_FOUND)
    message("-- Found BZLIB")
    set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
    set(OLD_CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES})
    set(OLD_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
    set(CMAKE_REQUIRED_FLAGS -lbz2)
    set(CMAKE_REQUIRED_INCLUDES ${BZIP_INCLUDE_DIRS})
    set(CMAKE_REQUIRED_LIBRARIES ${BZIP2_LIBRARIES})
    check_cxx_source_compiles("
        #include <bzlib.h>
        int main() { bz_stream stream; return 0; }"
        HAVE_BZLIB_CHECK)
    set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQUIRED_FLAGS})
    set(CMAKE_REQUIRED_INCLUDES ${OLD_CMAKE_REQUIRED_INCLUDES})
    set(CMAKE_REQUIRED_LIBRARIES ${OLD_CMAKE_REQUIRED_LIBRARIES})
    if(HAVE_BZLIB_CHECK)
        message("-- BZLIB works")
        target_include_directories(mmseqs-framework PUBLIC ${BZIP_INCLUDE_DIRS})
        target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_BZLIB=1)
        target_link_libraries(mmseqs-framework ${BZIP2_LIBRARIES})
    else ()
        message("-- BZLIB does not work")
    endif()
else ()
    message("-- Could not find BZLIB")
endif ()
endif ()

# MPI
if (HAVE_MPI)
    find_package(MPI REQUIRED)
    if (MPI_FOUND)
        message("-- Found MPI")
        target_include_directories(mmseqs-framework PUBLIC ${MPI_INCLUDE_PATH})
        #Hack (OMPI_SKIP_MPICXX=1): https://github.com/open-mpi/ompi/issues/5157#issuecomment-388495496
        target_compile_definitions(mmseqs-framework PUBLIC -DHAVE_MPI=1 -DOMPI_SKIP_MPICXX=1)
        target_link_libraries(mmseqs-framework ${MPI_LIBRARIES})
        append_target_property(mmseqs-framework COMPILE_FLAGS ${MPI_COMPILE_FLAGS})
        append_target_property(mmseqs-framework LINK_FLAGS ${MPI_LINK_FLAGS})
    endif ()
endif ()


find_package(OpenMP QUIET)
if (OPENMP_FOUND)
    message("-- Found OpenMP")
    target_compile_definitions(mmseqs-framework PUBLIC -DOPENMP=1)
    # For GCC we dont want to do this since it breaks macOS static builds
    # It will link libgomp.a internally (through -fopenmp I guess)
    # and also link libgomp.dylib thus breaking static builds
    if (NOT "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
        target_link_libraries(mmseqs-framework ${OpenMP_CXX_LIBRARIES})
    endif()
    append_target_property(mmseqs-framework COMPILE_FLAGS ${OpenMP_CXX_FLAGS})
    append_target_property(mmseqs-framework LINK_FLAGS ${OpenMP_CXX_FLAGS})
elseif (REQUIRE_OPENMP)
    message(FATAL_ERROR "-- Could not find OpenMP. Skip check with -DREQUIRE_OPENMP=0.")
endif ()

if (HAVE_GPROF)
    include(CheckCXXCompilerFlag)
    check_cxx_compiler_flag(-pg GPROF_FOUND)
    if (GPROF_FOUND)
        append_target_property(mmseqs-framework COMPILE_FLAGS -pg)
        append_target_property(mmseqs-framework LINK_FLAGS -pg)
    else ()
        message(FATAL_ERROR "-- Could not find GPROF")
    endif ()
endif ()

if (NOT FRAMEWORK_ONLY)
    include(MMseqsSetupDerivedTarget)
    add_subdirectory(version)
    set(mmseqs_source_files mmseqs.cpp)

    add_executable(mmseqs${EXE_SUFFIX} ${mmseqs_source_files})
    mmseqs_setup_derived_target(mmseqs${EXE_SUFFIX})
    target_link_libraries(mmseqs${EXE_SUFFIX} version)
    install(TARGETS mmseqs${EXE_SUFFIX} DESTINATION bin)

    if (HAVE_TESTS)
        add_subdirectory(test)
    endif ()
endif ()

=== lib/mmseqs/src/commons/CMakeLists.txt ===
set(commons_header_files
        commons/A3MReader.h
        commons/AminoAcidLookupTables.h
        commons/BacktraceTranslator.h
        commons/ByteParser.h
        commons/CSProfile.h
        commons/CSProfile.cpp
        commons/Command.h
        commons/CommandCaller.h
        commons/Concat.h
        commons/DBConcat.h
        commons/DBReader.h
        commons/DBWriter.h
        commons/IntervalArray.h
        commons/Debug.h
        commons/Domain.h
        commons/ExpressionParser.h
        commons/FileUtil.h
        commons/HeaderSummarizer.h
        commons/IndexReader.h
        commons/itoa.h
        commons/KSeqBufferReader.h
        commons/KSeqWrapper.h
        commons/MathUtil.h
        commons/MemoryMapped.h
        commons/MemoryTracker.h
        commons/MMseqsMPI.h
        commons/MultiParam.h
        commons/NucleotideMatrix.h
        commons/Orf.h
        commons/ProfileStates.h
        commons/LibraryReader.h
        commons/Parameters.h
        commons/PatternCompiler.h
        commons/ScoreMatrix.h
        commons/Sequence.h
        commons/StringBlock.h
        commons/SubstitutionMatrix.h
        commons/SubstitutionMatrixProfileStates.h
        commons/tantan.h
        commons/TranslateNucl.h
        commons/Timer.h
        commons/UniprotKB.h
        commons/Util.h
        PARENT_SCOPE
        )

set(commons_source_files
        commons/A3MReader.cpp
        commons/Application.cpp
        commons/BaseMatrix.cpp
        commons/Command.cpp
        commons/CommandCaller.cpp
        commons/DBConcat.cpp
        commons/DBReader.cpp
        commons/DBWriter.cpp
        commons/Debug.cpp
        commons/ExpressionParser.cpp
        commons/FileUtil.cpp
        commons/HeaderSummarizer.cpp
        commons/KSeqWrapper.cpp
        commons/MemoryMapped.cpp
        commons/MemoryTracker.cpp
        commons/MMseqsMPI.cpp
        commons/MultiParam.cpp
        commons/NucleotideMatrix.cpp
        commons/Orf.cpp
        commons/Parameters.cpp
        commons/ProfileStates.cpp
        commons/LibraryReader.cpp
        commons/Sequence.cpp
        commons/SubstitutionMatrix.cpp
        commons/tantan.cpp
        commons/UniprotKB.cpp
        commons/Util.cpp
        PARENT_SCOPE
        )

=== lib/mmseqs/src/test/CMakeLists.txt ===
include(MMseqsSetupTest)

set(TESTS
        #TestAdjustedKmerIterator.cpp
        TestAlignment.cpp
        TestAlignmentPerformance.cpp
        TestAlignmentTraceback.cpp
        TestAlp.cpp
        TestBacktraceTranslator.cpp
        TestCompositionBias.cpp
        TestCounting.cpp
        TestDBReader.cpp
        TestDBReaderIndexSerialization.cpp
        TestDiagonalScoring.cpp
        TestDiagonalScoringPerformance.cpp
        TestIndexTable.cpp
        TestKmerGenerator.cpp
        TestKmerNucl.cpp
        TestKmerScore.cpp
        TestKwayMerge.cpp
        TestMultipleAlignment.cpp
        TestProfileAlignment.cpp
        TestPSSM.cpp
        TestPSSMPrune.cpp
        TestDBReaderZstd.cpp
        TestReduceMatrix.cpp
        TestScoreMatrixSerialization.cpp
        TestSequenceIndex.cpp
        TestTanTan.cpp
        TestTaxonomy.cpp
        TestTranslate.cpp
        TestTinyExpr.cpp
        TestTaxExpr.cpp
        TestUtil.cpp
        TestKsw2.cpp
        TestBestAlphabet.cpp
        )


FOREACH (TEST ${TESTS})
    mmseqs_setup_test(${TEST})
ENDFOREACH ()

=== lib/mmseqs/src/util/CMakeLists.txt ===
set(util_source_files
        util/alignall.cpp
        util/alignbykmer.cpp
        util/appenddbtoindex.cpp
        util/apply.cpp
        util/clusthash.cpp
        util/compress.cpp
        util/convert2fasta.cpp
        util/convertalignments.cpp
        util/convertca3m.cpp
        util/convertkb.cpp
        util/convertmsa.cpp
        util/convertprofiledb.cpp
        util/createdb.cpp
        util/dbtype.cpp
        util/indexdb.cpp
        util/offsetalignment.cpp
        util/createseqfiledb.cpp
        util/createsubdb.cpp
        util/view.cpp
        util/createtsv.cpp
        util/diffseqdbs.cpp
        util/expandaln.cpp
        util/extractalignedregion.cpp
        util/extractdomains.cpp
        util/extractorfs.cpp
        util/orftocontig.cpp
        util/touchdb.cpp
        util/filterdb.cpp
        util/gff2db.cpp
        util/renamedbkeys.cpp
        util/masksequence.cpp
        util/maskbygff.cpp
        util/mergeclusters.cpp
        util/mergeresultsbyset.cpp
        util/mergedbs.cpp
        util/msa2profile.cpp
        util/msa2result.cpp
        util/nrtotaxmapping.cpp
        util/countkmer.cpp
        util/pairaln.cpp
        util/prefixid.cpp
        util/profile2pssm.cpp
        util/profile2seq.cpp
        util/result2dnamsa.cpp
        util/result2flat.cpp
        util/result2msa.cpp
        util/result2rbh.cpp
        util/result2profile.cpp
        util/result2repseq.cpp
        util/result2stats.cpp
        util/reverseseq.cpp
        util/cpmvrmlndb.cpp
        util/extractframes.cpp
        util/sequence2profile.cpp
        util/sortresult.cpp
        util/splitdb.cpp
        util/splitsequence.cpp
        util/subtractdbs.cpp
        util/summarizealis.cpp
        util/summarizeheaders.cpp
        util/summarizeresult.cpp
        util/summarizetabs.cpp
        util/swapresults.cpp
        util/transitivealign.cpp
        util/translatenucs.cpp
        util/translateaa.cpp
        util/tsv2db.cpp
        util/tsv2exprofiledb.cpp
        util/tar2db.cpp
        util/unpackdb.cpp
        util/proteinaln2nucl.cpp
        util/versionstring.cpp
        util/diskspaceavail.cpp
        PARENT_SCOPE
        )

## metaeuk 6-a5d39d9%2Bds

=== debian/changelog ===
metaeuk (6-a5d39d9+ds-4) unstable; urgency=medium

  * Team upload.
  * Add loong64 binary output for LoongArch
    Closes: #1059096

 -- Andreas Tille <tille@debian.org>  Tue, 09 Jan 2024 20:59:40 +0100

metaeuk (6-a5d39d9+ds-3) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * d/tests/control:
    Architecture: amd64 arm64 mips64el ppc64el ia64 kfreebsd-amd64 riscv64
    Depends: metaeuk
  * Drop redundant debian/gbp.conf
  * Add salsa-ci file (routine-update)

  [ Sascha Steinbiss ]
  * Fix FTBFS with GCC 13.
    Closes: #1042148

 -- Sascha Steinbiss <satta@debian.org>  Thu, 27 Jul 2023 12:27:38 +0200

metaeuk (6-a5d39d9+ds-2) unstable; urgency=medium

  * d/copyright: corrected license for some files to GPL-2+.
    Thanks to Thorsten Alteholz for noticing!

 -- Sascha Steinbiss <satta@debian.org>  Fri, 03 Feb 2023 09:22:17 +0100

metaeuk (6-a5d39d9+ds-1) unstable; urgency=low

  * Initial release (Closes: #1029432)

 -- Sascha Steinbiss <satta@debian.org>  Sun, 22 Jan 2023 15:21:28 +0100

=== debian/control ===
Source: metaeuk
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sascha Steinbiss <satta@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libgzstream-dev,
               libsimde-dev,
               libips4o-dev,
               libxxhash-dev,
               libzstd-dev,
               libbz2-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/metaeuk
Vcs-Git: https://salsa.debian.org/med-team/metaeuk.git
Rules-Requires-Root: no
Homepage: https://github.com/soedinglab/metaeuk

Package: metaeuk
# only little-endian and 64-bit
Architecture: amd64 arm64 mips64el ppc64el ia64 kfreebsd-amd64 riscv64 loong64
Depends: ${shlibs:Depends}, ${misc:Depends}
Built-Using: ${simde:Built-Using}
Description: sensitive, high-throughput gene discovery and annotation for metagenomics
 MetaEuk is a modular toolkit designed for large-scale gene discovery and
 annotation in eukaryotic metagenomic contigs. MetaEuk combines the fast and
 sensitive homology search capabilities of MMseqs2 with a dynamic programming
 procedure to recover optimal exons sets. It reduces redundancies in multiple
 discoveries of the same gene and resolves conflicting gene predictions on the
 same strand.

Package: metaeuk-examples
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: metaeuk
Description: optional resources for the metaeuk package
 MetaEuk is a modular toolkit designed for large-scale gene discovery and
 annotation in eukaryotic metagenomic contigs. MetaEuk combines the fast and
 sensitive homology search capabilities of MMseqs2 with a dynamic programming
 procedure to recover optimal exons sets. It reduces redundancies in multiple
 discoveries of the same gene and resolves conflicting gene predictions on the
 same strand.
 .
 This package contains example sequences for testing etc.

## metaeuk 6-a5d39d9+ds

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
 
 Package: metaeuk
 # only little-endian and 64-bit
-Architecture: amd64 arm64 mips64el ppc64el ia64 kfreebsd-amd64 riscv64 loong64
+Architecture: amd64 arm64 mips64el ppc64el ia64 kfreebsd-amd64 riscv64
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Built-Using: ${simde:Built-Using}
 Description: sensitive, high-throughput gene discovery and annotation for metagenomics

=== debian/watch ===
version=4
opts=repacksuffix=+ds,dversionmangle=s/\+ds//g,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/metaeuk-$1\.tar\.gz/ \
  https://github.com/soedinglab/metaeuk/tags .*/v?([^.]+)\.tar\.gz

## metaeuk 7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
project(metaeuk CXX)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/lib/mmseqs/cmake")

set(FRAMEWORK_ONLY 1 CACHE INTERNAL "" FORCE)
include(MMseqsSetupDerivedTarget)
add_subdirectory(lib/mmseqs)
add_subdirectory(data)
include_directories(lib)
add_subdirectory(src)

=== data/CMakeLists.txt ===
include(MMseqsResourceCompiler)

set(COMPILED_RESOURCES
        predictexons.sh
        easypredict.sh
        taxtocontig.sh
        )

set(GENERATED_OUTPUT_HEADERS "")
FOREACH(INPUT_FILE ${COMPILED_RESOURCES})
    compile_resource(${INPUT_FILE} OUTPUT_FILE)
    list(APPEND GENERATED_OUTPUT_HEADERS "${OUTPUT_FILE}")
ENDFOREACH()

add_custom_target(local-generated ALL DEPENDS ${GENERATED_OUTPUT_HEADERS})

=== src/CMakeLists.txt ===
include_directories(commons)
add_subdirectory(exonpredictor)
add_subdirectory(commons)
add_subdirectory(version)
add_subdirectory(workflow)

add_executable(metaeuk
        ${commons_source_files}
        ${exonpredictor_source_files}
        ${workflow_source_files}
        LocalCommandDeclarations.h
        metaeuk.cpp
        )
mmseqs_setup_derived_target(metaeuk)
target_link_libraries(metaeuk version)

add_dependencies(metaeuk local-generated)

install(TARGETS metaeuk DESTINATION bin)

=== src/commons/CMakeLists.txt ===
set(commons_source_files
        commons/LocalParameters.h
        PARENT_SCOPE)

=== src/exonpredictor/CMakeLists.txt ===
set(exonpredictor_source_files
        exonpredictor/resultspercontig.cpp
        exonpredictor/collectoptimalset.cpp
        exonpredictor/reduceredundancy.cpp
        exonpredictor/unitesetstofasta.cpp
        exonpredictor/groupstoacc.cpp
        PARENT_SCOPE
        )

=== src/workflow/CMakeLists.txt ===
set(workflow_source_files
        workflow/PredictExons.cpp
        workflow/EasyPredict.cpp
        workflow/TaxToContig.cpp
        PARENT_SCOPE
        )

=== lib/mmseqs/src/CMakeLists.txt ===
--- 
+++ 
@@ -76,8 +76,8 @@
 endif()
 
 if (ENABLE_WERROR)
-    append_target_property(mmseqs-framework COMPILE_FLAGS -Werror)
-    append_target_property(mmseqs-framework LINK_FLAGS -Werror)
+    append_target_property(mmseqs-framework COMPILE_FLAGS -Werror -Wno-unused-command-line-argument)
+    append_target_property(mmseqs-framework LINK_FLAGS -Werror -Wno-unused-command-line-argument)
 endif()
 
 # needed for concat.h
@@ -222,6 +222,7 @@
     if (NOT "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
         target_link_libraries(mmseqs-framework ${OpenMP_CXX_LIBRARIES})
     endif()
+    target_include_directories(mmseqs-framework PUBLIC ${OpenMP_CXX_INCLUDE_DIRS})
     append_target_property(mmseqs-framework COMPILE_FLAGS ${OpenMP_CXX_FLAGS})
     append_target_property(mmseqs-framework LINK_FLAGS ${OpenMP_CXX_FLAGS})
 elseif (REQUIRE_OPENMP)

=== lib/mmseqs/lib/cacode/CMakeLists.txt ===
add_library(cacode OBJECT
        lambda_calculator.cpp
        lambda_calculator.h
        lubksb.cpp
        ludcmp.cpp
        nrutil.cpp
        nrutil.h
        )
set_target_properties(cacode PROPERTIES COMPILE_FLAGS "${MMSEQS_CXX_FLAGS} -w" LINK_FLAGS "${MMSEQS_CXX_FLAGS} -w")

=== lib/mmseqs/src/util/CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,7 @@
         util/convertprofiledb.cpp
         util/createdb.cpp
         util/dbtype.cpp
+        util/db2tar.cpp
         util/indexdb.cpp
         util/offsetalignment.cpp
         util/createseqfiledb.cpp
@@ -26,14 +27,17 @@
         util/extractorfs.cpp
         util/orftocontig.cpp
         util/touchdb.cpp
+        util/filtera3m.cpp
         util/filterdb.cpp
         util/gff2db.cpp
         util/renamedbkeys.cpp
+        util/makepaddedseqdb.cpp
         util/masksequence.cpp
         util/maskbygff.cpp
         util/mergeclusters.cpp
         util/mergeresultsbyset.cpp
         util/mergedbs.cpp
+        util/createclusterdb.cpp
         util/msa2profile.cpp
         util/msa2result.cpp
         util/nrtotaxmapping.cpp
@@ -41,7 +45,9 @@
         util/pairaln.cpp
         util/prefixid.cpp
         util/profile2pssm.cpp
+        util/profile2neff.cpp
         util/profile2seq.cpp
+        util/recoverlongestorf.cpp
         util/result2dnamsa.cpp
         util/result2flat.cpp
         util/result2msa.cpp
@@ -53,8 +59,10 @@
         util/cpmvrmlndb.cpp
         util/extractframes.cpp
         util/sequence2profile.cpp
+        util/setextendeddbtype.cpp
         util/sortresult.cpp
         util/splitdb.cpp
+        util/setextendeddbtype.cpp
         util/splitsequence.cpp
         util/subtractdbs.cpp
         util/summarizealis.cpp

## metaeuk 7-bba0d80+ds

=== debian/changelog ===
metaeuk (7-bba0d80+ds-2) unstable; urgency=medium

  * Add -DCMAKE_POLICY_VERSION_MINIMUM=3.5 to enable building with CMake 4.
    Closes: #1113280
  * Make sure to link against Debian's libgzstream.
  * Avoid using FSF's postal address in d/copyright.
  * Bump Standards-Version.

 -- Sascha Steinbiss <satta@debian.org>  Sat, 11 Oct 2025 06:49:52 +0200

metaeuk (7-bba0d80+ds-1) unstable; urgency=medium

  * New upstream release.
  * Remove patches applied upstream.

 -- Sascha Steinbiss <satta@debian.org>  Tue, 04 Jun 2024 00:30:02 +0200

metaeuk (6-a5d39d9+ds-5) unstable; urgency=medium

  * Team upload.
  * d/control: simplify architecture list using the provisions from the
    architecture-properties package.
  * d/rules: ensure that the openmp-simd and other relevant SIMDe build
    flags are set.
  * d/patches/debian-libs.patch: mark as not needing forwarding to
    upstream.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 25 Mar 2024 16:55:09 +0100

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,8 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+               architecture-is-64-bit,
+               architecture-is-little-endian,
                cmake,
                libgzstream-dev,
                libsimde-dev,
@@ -11,15 +13,14 @@
                libxxhash-dev,
                libzstd-dev,
                libbz2-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/metaeuk
 Vcs-Git: https://salsa.debian.org/med-team/metaeuk.git
 Rules-Requires-Root: no
 Homepage: https://github.com/soedinglab/metaeuk
 
 Package: metaeuk
-# only little-endian and 64-bit
-Architecture: amd64 arm64 mips64el ppc64el ia64 kfreebsd-amd64 riscv64
+Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Built-Using: ${simde:Built-Using}
 Description: sensitive, high-throughput gene discovery and annotation for metagenomics

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk
export DEB_CFLAGS_MAINT_APPEND+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
export DEB_CXXFLAGS_MAINT_APPEND+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3

cmake_flags=-DUSE_SYSTEM_ZSTD=1 -DVERSION_OVERRIDE=$(DEB_VERSION) -DNATIVE_ARCH=0 -DCMAKE_POLICY_VERSION_MINIMUM=3.5

%:
	dh $@

override_dh_gencontrol:
	dh_gencontrol -- -Vsimde:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsimde-dev")"

override_dh_auto_configure:
	dh_auto_configure -- $(cmake_flags)

=== debian/tests/control ===
Tests: run-tests
Depends: @, metaeuk
Restrictions: allow-stderr
Architecture: amd64 arm64 mips64el ppc64el ia64 kfreebsd-amd64 riscv64 loong64

=== debian/watch ===
version=4
opts=repacksuffix=+ds,dversionmangle=auto,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/metaeuk-$1\.tar\.gz/ \
  https://github.com/soedinglab/metaeuk/tags .*/v?([^.]+)\.tar\.gz
